<shopping_list>
    <section id="accessory" class="row column">
        <div class="row text-center">
          <h1>訂單資訊</h1>
          <h2>ORDER INFORMATION</h2>
        </div>
        <hr class="fancy" />
        <!--<div class="row item">-->
        <!--    <div class="column small-12 medium-2">產品名稱</div>-->
        <!--    <div class="column small-12 medium-2 text-right end">數量</div>-->
        <!--</div>-->
        <div class="row item" each={product in shopping_list}>
            <div class="column small-12 medium-4 medium-offset-3"><span onclick="{removeFromShoppingList}"><i style="cursor: pointer" class="fa fa-times-circle" aria-hidden="true"></i></span> [{product.category_name}] {product.name}</div>
            <div class="column small-12 medium-2 text-right end"><input onchange="{updateQty}" value={product.qty} style="width: 40%; border: none; text-align: right" /> pcs <i style="cursor: pointer" class="fa fa-minus-circle" aria-hidden="true" onclick="{decQty}"></i> <i style="cursor:pointer" class="fa fa-plus-circle" aria-hidden="true" onclick="{incQty}"></i> </div>
        </div>
        <div class="text-center" style="margin-top: 1em"><a style="padding: 0.2em 1em 0.2em 1em;" onclick="{submitOrder}">傳送訂單</a></div>
    </section>
    <style>
        shopping_list .item{
            border-bottom: 1px dashed #B90000;
            padding-top: 1em;
        }
    </style>
    <script>
        var tag = this;
        tag.shopping_list = new Array();
        tag.db = null;
        tag.request = null;
        tag.connect = null;
        tag.on('mount', function(){
            tagRegister.shopping_list = this;
            // var db = openDatabase('mall', '1.0', 'Mall DB', 2 * 1024 * 1024);
            // console.log(db);
            // db.transaction(function (tx) {
            //     console.log(tx);
            //     tx.executeSql('CREATE TABLE IF NOT EXISTS shopping_list (id unique, product_id, product_name, product_price, qty)', function (tx, results) {
            //         console.log(results);
            //         tx.executeSql("SELECT * FROM shopping_list", [], function(tx, results){
            //             console.log(results);
            //             for ( var i = 0 ; i < results.rows.length; ++i )
            //                 tag.shopping_list.push(results.rows[i]);
            //             tag.update();
                        
            //         });
            //     });
            // });
            
            window.indexedDB = window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
 
            window.IDBTransaction = window.IDBTransaction || window.webkitIDBTransaction || window.msIDBTransaction;
            window.IDBKeyRange = window.IDBKeyRange || window.webkitIDBKeyRange || window.msIDBKeyRange
             
            if (!window.indexedDB) {
                window.alert("Your browser doesn't support a stable version of IndexedDB.");
            }
            
            tag.connect = window.indexedDB.open("Mall", 1);
            tag.connect.onerror = function(event) {
                console.log("error: ");
            };
            tag.connect.onsuccess = function(event) {
                tag.db = tag.connect.result;
                console.log("success: "+ tag.db);
                tag.loadShoppingList();
            };
            tag.connect.onupgradeneeded = function() {
                var db = tag.connect.result;
                var store = db.createObjectStore("shopping_list", {keyPath: "id_product"});
                console.log(store);
            }
            
        });
        tag.loadShoppingList = function(){
            tag.shopping_list = null;
            tag.shopping_list = new Array();
            var objectStore = tag.db.transaction("shopping_list").objectStore("shopping_list");
            objectStore.openCursor().onsuccess = function(event) {
                var cursor = event.target.result;
                if (cursor) {
                //   alert("Name for id " + cursor.key + " is " + cursor.value.name + ", Age: " + cursor.value.age + ", Email: " + cursor.value.email);
                    // console.log(cursor.value);
                    tag.shopping_list.push(cursor.value);
                    cursor.continue();
                }else {
                    // alert("No more entries!");
                }
                tag.update();
            };
        }
        tag.removeFromShoppingList = function(obj){
            // console.log(obj.item.product);
            var request = tag.db.transaction("shopping_list", "readwrite")
            .objectStore("shopping_list")
            .delete(obj.item.product.id_product);
            tagRegister.shopping_list.loadShoppingList();
        }
        tag.incQty = function(obj){
            var query = tag.db.transaction("shopping_list", "readwrite")
            .objectStore("shopping_list")
            .get(obj.item.product.id_product);
            
            // console.log(request);
            query.onsuccess = function(event) {
                // console.log(query);
                if(typeof(query.result)=='undefined') {
                    obj.item.product.qty = 0;
                    var request = tag.db.transaction("shopping_list", "readwrite")
                    .objectStore("shopping_list")
                    .add(obj.item.product);
                }
                obj.item.product.qty += 1;
                var request = tag.db.transaction("shopping_list", "readwrite")
                .objectStore("shopping_list")
                .put(obj.item.product);
                tagRegister.shopping_list.loadShoppingList();
            }
        }
        tag.decQty = function(obj){
            var query = tag.db.transaction("shopping_list", "readwrite")
            .objectStore("shopping_list")
            .get(obj.item.product.id_product);
            
            // console.log(request);
            query.onsuccess = function(event) {
                // console.log(query);
                if(typeof(query.result)=='undefined') {
                    obj.item.product.qty = 0;
                    var request = tag.db.transaction("shopping_list", "readwrite")
                    .objectStore("shopping_list")
                    .add(obj.item.product);
                }
                obj.item.product.qty -= 1;
                var request = tag.db.transaction("shopping_list", "readwrite")
                .objectStore("shopping_list")
                .put(obj.item.product);
                tagRegister.shopping_list.loadShoppingList();
            }
        }
        tag.updateQty = function(obj){
        }
        tag.submitOrder = function(){
            console.log(tag.shopping_list);
            $.post('/api/orders', {UserId: sessionStorage.getItem('UserId'), ShoppingList: tag.shopping_list}, function(data){
                console.log(data);
            });
        }
    </script>
</shopping_list>